package cn.com.qmth.examcloud.core.examwork.dao;

import cn.com.qmth.examcloud.core.examwork.dao.entity.ExamIpLimitEntity;
import cn.com.qmth.examcloud.core.examwork.dao.enums.IpLimitType;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.data.jpa.repository.Modifying;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.query.QueryByExampleExecutor;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;

public interface ExamIpLimitRepo extends JpaRepository<ExamIpLimitEntity, Long>,
			QueryByExampleExecutor<ExamIpLimitEntity>, JpaSpecificationExecutor<ExamIpLimitEntity> {

	@Query(value = "SELECT count(1) from ec_e_exam_ip_limit t where t.exam_id = ?1 " +
			"AND t.limit_type = ?2 AND t.ip = ?3",nativeQuery = true)
	int countByExamIdAndLimitTypeAndIp(Long examId, String limitType, String ip);

	@Modifying
	@Transactional
	@Query(value = "update ExamIpLimitEntity t set t.limitType = ?1" +
			" where t.examId = ?2 and t.id in ?3")
	int updateLimitType(IpLimitType LimitType, Long examId, List<Long> ids);

	int deleteByIdIn(List<Long> ipIds);

	int deleteAllByExamId(Long examId);

}
